//+------------------------------------------------------------------+
//|                                                       30pips.mq4 |
//|                                                           m1rr0r |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "m1rr0r"
#property link      "http://www.forex-tsd.com/suggestions-trading-systems/3843-mt4-30-pips-system.html"
#include <StdLib.mqh>

extern double TakeProfit = 30;
extern double StopLoss = 170;
extern double Lots = 0.1;
extern int _Magic = 123456;
extern int slip = 3;

int total;
double MACD,MACD1,MACD2;

int init() {
   return(0);
}

int start() {
   total = OrdersTotal();
   MACD = iMACD(NULL,0,8,21,13,PRICE_CLOSE,MODE_SIGNAL,1);
   MACD1 = iMACD(NULL,0,8,21,13,PRICE_CLOSE,MODE_SIGNAL,2);
   MACD2 = iMACD(NULL,0,8,21,13,PRICE_CLOSE,MODE_SIGNAL,3);
   
   Lots = NormalizeDouble(AccountEquity()*0.01/1000.0,1);
   if (Lots <=0.1) Lots=0.1;
   //MACD increases
   if (MACD>MACD1) {
      if (!isExists(Ask,OP_BUY,TakeProfit)) Buy();
   }
   //MACD decreases
   if (MACD<MACD1) {
      if (!isExists(Bid,OP_SELL,TakeProfit)) Sell();
   }
   
   //Exit strategy;)
   //bottom-up crossing
   if (MACD>0 && MACD1<0) {
      CloseOrders(OP_SELL);
   }
   //top-down crossing
   if (MACD<0 && MACD1>0) {
      CloseOrders(OP_BUY);
   }
   
   return(0);
}



int Buy() {
   int ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,slip,0,Ask+TakeProfit*Point,"",_Magic,0,Green);
   if(ticket<0) {
      Print("ERROR: BUY - ",ErrorDescription(GetLastError()));
      return(-1);
   }
   
   return(ticket);
}

int Sell() {
   int ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,slip,0,Bid-TakeProfit*Point,"",_Magic,0,Green);
   if(ticket<0) {
      Print("ERROR: SELL - ",ErrorDescription(GetLastError()));
      return(-1);
   }
   
   return(ticket);      
}

bool isExists(double Price, int type, double eps) {
   for(int i=total-1;i>=0;i--) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);   
      if (MathAbs(OrderOpenPrice()-Price)<eps*Point && OrderType()==type)
         return(true);
   }
   
   return(false);
}
  
int BuyStop(double Price) {
   if (Price>Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) {
      int ticket = OrderSend(Symbol(),OP_BUYSTOP,Lots,Price,slip,Price-StopLoss*Point,Price+TakeProfit*Point,"",_Magic,0,Green);
      if(ticket<0) {
         Print("ERROR: BUY - ",ErrorDescription(GetLastError()));
         return(-1);
      }
   }
   
   return(ticket);
}

int SellStop(double Price) {
   if (Price<Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) {
      int ticket = OrderSend(Symbol(),OP_SELLSTOP,Lots,Price,slip,Price+StopLoss*Point,Price-TakeProfit*Point,"",_Magic,0,Green);
      if(ticket<0) {
         Print("ERROR: SELL - ",ErrorDescription(GetLastError()));
         return(-1);
      }
   }
   
   return(ticket);      
}

void ClosePending(int type) {
   int totalOrders = OrdersTotal();
   
   if (totalOrders==0)
      return;
      
   for(int i=0;i<totalOrders;i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType()==type)
      switch(OrderType()) {
         case OP_BUYSTOP:
            //OrderClose(OrderTicket(),OrderLots(),OrderOpenPrice(),slip);
            OrderDelete(OrderTicket());
            break;
         case OP_SELLSTOP:
            //OrderClose(OrderTicket(),OrderLots(),OrderOpenPrice(),slip);
            OrderDelete(OrderTicket());
            break;
         default:
            break;
      }   
   }

}

void CloseAll() {
   int totalOrders = OrdersTotal();
   
   if (totalOrders==0)
      return;
      
   for(int i=0;i<totalOrders;i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      switch(OrderType()) {
         case OP_BUY:
            OrderClose(OrderTicket(),OrderLots(),Bid,slip);
            break;
         case OP_SELL:
            OrderClose(OrderTicket(),OrderLots(),Ask,slip);
            break;
         default:
            break;
      }   
   }
}   

void CloseOrders(int type) {
   int totalOrders = OrdersTotal();
   
   if (totalOrders==0)
      return;
      
   for(int i=0;i<totalOrders;i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType()==type)
      switch(type) {
         case OP_BUY:
            OrderClose(OrderTicket(),OrderLots(),Bid,slip);
            break;
         case OP_SELL:
            OrderClose(OrderTicket(),OrderLots(),Ask,slip);
            break;
         case OP_BUYSTOP:
            //OrderClose(OrderTicket(),OrderLots(),OrderOpenPrice(),slip);
            OrderDelete(OrderTicket());
            break;
         case OP_SELLSTOP:
            //OrderClose(OrderTicket(),OrderLots(),OrderOpenPrice(),slip);
            OrderDelete(OrderTicket());
            break;
         default:
            break;
      }   
   }

}   

